/*
 * SPI.c
 *
 *  Created on: 14.03.2012
 *      Author: darkhedie
 */

#include <avr/io.h>
#include "SPI.h"


void delay_clk(unsigned int delay)
{
    while(delay) delay--;
}

void init_spi(void)
{
    sclk_0;
    CS_1;
}


void write_spi (unsigned char data_out)
{       //msb first
    unsigned char mask;
    for (mask=0x80; mask; mask=mask>>1)
    {
        sclk_0;
        delay_clk(delay_value);
        if (data_out & mask)
        {
        	mosi_1;
        }
        else mosi_0;
        sclk_1;
    }
    sclk_0;
}

unsigned char read_spi (void)
{       //msb first
    unsigned char ucTemp = 0;
    unsigned char ucCounter = 0;
    mosi_1;     //DummyByte 0xFF
    for (ucCounter=0; ucCounter!=8; ucCounter++)
    {
        sclk_0;
        delay_clk(delay_value);
        sclk_1;
        if (miso) ucTemp = (ucTemp | 0x01);
        else ucTemp = ucTemp & 0xFE;
        if(ucCounter < 7) ucTemp = ucTemp << 1;
    }
    sclk_0;
    return ucTemp;
}


#if _USE_CSFUNC
void spi_cs(unsigned char ucState)
{
	if(ucState)
	{
		CS_1
	}
	else
	{
		CS_0;
	}
}
#endif

#if _USE_TRANSFER
unsigned char transfer_spi(unsigned char ucData)
{
    unsigned char ucTemp = 0;
    unsigned char ucCounter = 0;
    unsigned char mask = 0x80;
    for (ucCounter=0; ucCounter!=8; ucCounter++)
    {
        sclk_0;
        if (ucData & mask)
		{
			mosi_1;
		}
		else mosi_0;
        mask=mask>>1;
		sclk_1;
        delay_clk(delay_value);
        sclk_1;
        if (miso) ucTemp = (ucTemp | 0x01);
        else ucTemp = ucTemp & 0xFE;
        if(ucCounter < 7) ucTemp = ucTemp << 1;
    }
    sclk_0;
    return ucTemp;
}
#endif






