/*
 * interface.c
 *
 *  Created on: 08.10.2012
 *      Author: darkhedie
 */


#include "interface.h"
#include "SPI.h"


void spi_unselect_all(void)
{
	CC2500_CS_1;
	PHY_CS_1;
	SD_CS_1;
}


void write_to_spi(unsigned char Device, unsigned char ucData)
{
	switch(Device)
	{
	case dvc_CC2500:
		CC2500_CS_0; //Device selektieren
		write_spi(ucData);
		CC2500_CS_1;
		break;

	case dvc_ETH:
		PHY_CS_0;
		write_spi(ucData);
		PHY_CS_1;
		break;

	case dvc_SDCard:
		SD_CS_0;
		write_spi(ucData);
		SD_CS_1;
		break;

	case dvc_none:
		write_spi(ucData);
		break;
	}
}

unsigned char read_from_spi(unsigned char Device)
{
	unsigned char ucTemp = 0;
	switch(Device)
	{
	case dvc_CC2500:
		CC2500_CS_0; //Device selektieren
		ucTemp = read_spi();
		CC2500_CS_1;
		break;

	case dvc_ETH:
		PHY_CS_0;
		ucTemp = read_spi();
		PHY_CS_1;
		break;

	case dvc_SDCard:
		SD_CS_0;
		ucTemp = read_spi();
		SD_CS_1;
		break;

	case dvc_none:
		return read_spi();
		break;
	}
	return ucTemp;
}

unsigned char transfer_to_spi(unsigned char Device, unsigned char ucData)
{
	unsigned char ucTemp = 0;
	switch(Device)
	{
	case dvc_CC2500:
		CC2500_CS_0; //Device selektieren
		ucTemp = transfer_spi(ucData);
		CC2500_CS_1;
		break;

	case dvc_ETH:
		PHY_CS_0;
		ucTemp = transfer_spi(ucData);
		PHY_CS_1;
		break;

	case dvc_SDCard:
		SD_CS_0;
		ucTemp = transfer_spi(ucData);
		SD_CS_1;
		break;

	case dvc_none:
		ucTemp = transfer_spi(ucData);
		break;
	}
	return ucTemp;
}






