/*
 * interface_h
 *
 *  Created on: 08_10_2012
 *      Author: darkhedie
 */

#include <avr/io.h>
#include "../avrlibtypes.h"

#ifndef INTERFACE_H_
#define INTERFACE_H_



/// Define on-board devices

#define	dvc_none	0
#define dvc_CC2500	1
#define dvc_ETH		2
#define dvc_SDCard	3



/// Define Ports

#define PHY_CS_1 	PORTB |= (1<<PB0)
#define PHY_CS_0	PORTB &= ~(1<<PB0)

#define CC2500_CS_1 	PORTB |= (1<<PB1)
#define CC2500_CS_0		PORTB &= ~(1<<PB1)

#define SD_CS_1 	PORTB |= (1<<PB2)
#define SD_CS_0		PORTB &= ~(1<<PB2)


#define	RF_GDO0		( PINB & (1<<PINB3) )
#define	RF_GDO2		( PINB & (1<<PINB4) )

#define SPI_SO_1 	PORTB |= (1<<PB5)
#define SPI_SO_0	PORTB &= ~(1<<PB5)

#define	SPI_SI		( PINB & (1<<PINB6) )

#define SPI_SCK_1 	PORTB |= (1<<PB7)
#define SPI_SCK_0	PORTB &= ~(1<<PB7)


#define	UART_RX		( PIND & (1<<PIND0) )

#define UART_TX_1 	PORTD |= (1<<PD1)
#define UART_TX_0	PORTD &= ~(1<<PD1)

//USB D- 			PORTD_2

#define	PHY_INT		( PIND & (1<<PIND3) )

#define PHY_RST_1 	PORTD |= (1<<PD4)
#define PHY_RST_0	PORTD &= ~(1<<PD4)

//FREI	 			PORTD_5

//USB D+ 			PORTD_6

//FREI				PORTD_7


/*
 * 	ExpansionPort  -> 1 <-
 */

#define EXP_1_6_1	PORTA |=  (1<<PA0)
#define EXP_1_6_0	PORTA &= ~(1<<PA0)
#define	EXP_1_6		(PINA & (1<<PINA0))

#define EXP_1_7_1	PORTA |=  (1<<PA1)
#define EXP_1_7_0	PORTA &= ~(1<<PA1)
#define	EXP_1_7		(PINA & (1<<PINA1))

#define EXP_1_8_1	PORTA |=  (1<<PA2)
#define EXP_1_8_0	PORTA &= ~(1<<PA2)
#define	EXP_1_8		(PINA & (1<<PINA2))

#define EXP_1_9_1	PORTA |=  (1<<PA3)
#define EXP_1_9_0	PORTA &= ~(1<<PA3)
#define	EXP_1_9		(PINA & (1<<PINA3))

#define EXP_1_10_1	PORTA |=  (1<<PA4)
#define EXP_1_10_0	PORTA &= ~(1<<PA4)
#define	EXP_1_10	(PINA & (1<<PINA4))

#define EXP_1_11_1	PORTA |=  (1<<PA5)
#define EXP_1_11_0	PORTA &= ~(1<<PA5)
#define	EXP_1_11	(PINA & (1<<PINA5))

#define EXP_1_12_1	PORTA |=  (1<<PA6)
#define EXP_1_12_0	PORTA &= ~(1<<PA6)
#define	EXP_1_12	(PINA & (1<<PINA6))

/*
 * 	ExpansionPort  -> 2 <-
 */


#define EXP_2_3_1	PORTA |=  (1<<PA7)
#define EXP_2_3_0	PORTA &= ~(1<<PA7)
#define	EXP_2_3		(PINA & (1<<PINA7))

#define EXP_2_6_1	PORTC |=  (1<<PC2)
#define EXP_2_6_0	PORTC &= ~(1<<PC2)
#define	EXP_2_6		(PINC & (1<<PINC2))


#define I2C_SCL_1	PORTC |=  (1<<PC0)
#define I2C_SCL_0	PORTC &= ~(1<<PC0)

#define I2C_SDA_1	PORTC |=  (1<<PC1)
#define I2C_SDA_0	PORTC &= ~(1<<PC1)

#define	I2C_SDA		(PINC & (1<<PINC1))


#define LED_STAT_1	PORTC |=  (1<<PC3)
#define LED_STAT_0	PORTC &= ~(1<<PC3)

#define LED_ACT_1	PORTC |=  (1<<PC4)
#define LED_ACT_0	PORTC &= ~(1<<PC4)


#define RGB_R_1	PORTC |=  (1<<PC5)
#define RGB_R_0	PORTC &= ~(1<<PC5)

#define RGB_G_1	PORTC |=  (1<<PC6)
#define RGB_G_0	PORTC &= ~(1<<PC6)

#define RGB_B_1	PORTC |=  (1<<PC7)
#define RGB_B_0	PORTC &= ~(1<<PC7)






/*
 *  Function Prototypes
 */

unsigned char transfer_to_spi(unsigned char Device, unsigned char ucData);
unsigned char read_from_spi(unsigned char Device);
void write_to_spi(unsigned char Device, unsigned char ucData);
void spi_unselect_all(void);


// config ports

// config expansion ports -> bool cfg_exp(Port 1:2, Pin 0:7, I/O Input-Output);

// check for physical devices

// check for address

// i2c routines

// spi routines







#endif /* INTERFACE_H_ */











