/*
 * main.c
 *
 *	colix BaseBoard Firmware - Development state
 *
 *
 *	Actual version: 1.0 pre alpha
 *
 *  Created on: 08.10.2012
 *      Author: C. Hediger
 */



#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "Interface/interface.h"
#include "System/system.h"
#include "UART/UART.h"
#include "Wireless/mrfd.h"

#include "Ethernet/stack.h"
#include "Ethernet/enc28j60.h"
#include "RGB/RGB.h"
#include "Ethernet/colixLayer.h"


//---SD Card---
//disk_initialize()
//pf_mount(&fs)
//pf_open("sound.wav")
//pf_read(myBuff1, 256, &s1);



ISR(INT1_vect)
{
	//interrupt_INT1(0); //Deaktivieren
	//incomingPacketCounter++;
	//uart_send_var(incomingPacketCounter);
	//uart_putc('\n');
	cli();
	LED_ACT_1;
	//_delay_ms(50);
	LED_ACT_0;

	while((enc28j60Read(EIR) & EIR_PKTIF))
	{
		//uart_puts("Weiteres Paket vorhanden!\n");
		process_packet(enc28j60PacketReceive(ETH_buffer_SIZE, ETH_buffer));
	}

	sei();
	//uart_puts("Interrupt ende\n");

	//interrupt_INT1(1); //Interrupt aktivieren
}



int main(void)
{


	startup();
	interrupt_INT1(0);
	uart_init(TX);

	uiPWMBlue = 0;
	uiPWMGreen = 0;
	uiPWMRed = 0;
	uart_init(TX);

	CC2500_CS_1;
	PHY_CS_1;

	PHY_RST_0;
	_delay_ms(10);
	PHY_RST_1;
	_delay_ms(10);

	LED_ACT_1;

	//sei();
	//while(1);

	MRFD_Init();
	MRFD_RxOn();
	sei();
	LED_ACT_0;

	mrfdPacket_t myPacket;

	myPacket.frame[0] = 3;
	myPacket.frame[1] = 0xBB;
	myPacket.frame[2] = 0xCC;
	myPacket.frame[3] = 10;


	//uart_puts("-Versuche einen enc INIT...\n");
	enc28j60Init();				//ETH Initialisieren
	nicSetMacAddress(mymac);	//Mac Adresse setzen
	enc28j60PhyWrite(0x14,0b0000010000100000); //LED's konfigurieren
	//enc28j60PhyWrite(0x14,0b0000010000100000);

	LED_ACT_0;

	unsigned int uiHue = 0;

	while(1)
	{

		//enc28j60Read
		LED_ACT_0;
		while((enc28j60Read(EIR) & EIR_PKTIF))
		{
			//cli();
			//uart_puts("Weiteres Paket vorhanden!\n");

			LED_ACT_1;
			enc28j60PacketReceive(ETH_buffer_SIZE, ETH_buffer);


			//process_packet()
			//process_packet(enc28j60PacketReceive(ETH_buffer_SIZE, ETH_buffer));
			//sei();
		}

		//LED_ACT_0;

		//hue_to_rgb(uiHue);
		//uiHue++;
		//if(uiHue > HUE_MAX) uiHue = 0;

		/*
		LED_STAT_1;
		MRFD_TransmitPacket(&myPacket);

		LED_STAT_0;
		MRFD_TransmitPacket(&myPacket);
*/
		LED_STAT_1;
		LED_STAT_0;




		//LED_ACT_1;
		//LED_STAT_1;
		//printinbuffer(&buffer[UDP_DATA],"Hallo, dies ist ein Test des AVR Boardes :) Es laeuft alles perfekt hehehe",TERMINATE);
		//send_over_udp(74,buffer,85,99);


		//_delay_ms(1000);
		//LED_STAT_0;
		//LED_ACT_0;
		//printinbuffer(&buffer[UDP_DATA],"Hallo, dies ist ein Test des AVR Boardes :) Es laeuft alles perfekt hehehe",TERMINATE);
		//send_over_udp(74,buffer,85,99);


	}

}
