/*
 * system.c
 *
 *  Created on: 08.10.2012
 *      Author: darkhedie
 */

#include "system.h"
#include "../Ethernet/colixLayer.h"

volatile unsigned int uiSysTickCount = 0;
unsigned char ucConnected_Devices = 0;

unsigned char ucMinuten = 0;
unsigned char ucStunden = 0;
unsigned char ucWochentag = 0;


/*einfache memcpy*/
void printinbuffer(uint8_t *buff,uint8_t *text,uint8_t terminate){
	while(*text){
		*buff++ = *text++;
	}
	if(terminate) *buff++ = 0x00;
}


/*	einfache strcmp, zwecks Lerneffekt auch selbst gemacht*/
uint8_t compare(uint8_t *buffone, uint8_t *bufftwo){

	uint8_t counterone=0,countertwo=0;
	while(*bufftwo){
		if(*buffone++ == *bufftwo++){counterone++;}
		countertwo++;
	}
	if(counterone==countertwo) return(1);
	return(0);

}

void port_init(void)
{
	//Eingnge
	DDRB &= ~((1 << DDB3) | (1 << DDB4) | (1 << DDB6));
	DDRD &= ~((1 << DDD0) | (1 << DDD3));


	//Ausgnge
	DDRB |= (1 << DDB0) | (1 << DDB1) | (1 << DDB2) | (1 << DDB5) | (1 << DDB7);
	DDRD |= (1 << DDD1) | (1 << DDD4);
	DDRC |= (1 << DDC0) | (1 << DDC1) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5) | (1 << DDC6) | (1 << DDC7);

}

void interrupt_INT1(unsigned char ucState)
{
	if(ucState)
	{
		EIMSK 	|= (1<<INT1); 		//ETH Paket Interrupt
	}
	else
	{
		EIMSK &= ~(1<<INT1); //Int deaktivieren
	}
}

void interrupt_init(void)
{
	//EICRA 	|= (1<<ISC11); 		//Fallende Flanke am INT1
	//EIMSK 	|= (1<<INT1); 		//ETH Paket Interrupt

	PCMSK1 	|= (1<<PCINT11); 	//PCINT11 Maskieren (auswhlen)
	PCICR 	|= (1<<PCIE1); 		//PCINT's fr das Grppchen 1 wo PCINT11 auch dabei ist, zulassen.
}

void timer_init(void)
{

	TCCR0A |= (1<<WGM01);	//CTC Modus fr Timer0
	TCCR0B |= (1<<CS01) | (1<<CS00);  	//CLK / 64 = 156.25KHz
	OCR0A = 8-1;			//nochmals durch 7 teilen = 22.321KHz (durch ISR divided / 300) = 74.40Hz PWM Frequenz!
	TIMSK0 |= (1<<OCIE0A); 	//Interrupt beim erreichen des TOP wertes
}

int startup(void)
{
	//Ports initialisieren
	port_init();
	interrupt_init();
	timer_init();

	incomingPacketCounter = 0;

	//Uart initialisieren

	//Timer konfigurieren, systick

	//LEDs blinken lassen

	//on-board devices checken und in ucConnected... schreiben

	//
	return 1;

}

